<template>
  <div ref="chartRef" style="width: 100%; min-height: 500px"></div>
</template>

<script lang="ts">
import { api } from 'src/boot/axios/index';
import { defineComponent, onMounted, Ref, ref } from 'vue';

import * as echarts from 'echarts';

import { AxiosResponse } from 'axios';
import { GraficoTortaInterface } from 'src/interfaces/VariosInterface';

export default defineComponent({
  props: {
    url: {
      type: String,
      required: true,
    },
    descripcion: {
      type: String,
      required: false,
    },
  },

  setup(props) {
    const chartRef: Ref<HTMLDivElement | null> = ref(null);
    var chartInstance: echarts.ECharts | null = null;

    const option = ref<echarts.EChartsOption>({
      // grid: { containLabel: true },

      grid: {
        left: '4%',
        right: '4%',
        bottom: '4%',
        containLabel: true,
      },

      xAxis: { name: 'Total' },
      yAxis: {},
      // visualMap <= si habilito el visualMap, no muestra los colores de las barras !
      series: [],

      tooltip: {
        trigger: 'axis',
        axisPointer: {
          type: 'shadow',
        },
      },
    });

    onMounted(() => {
      getData();
    });

    function getData() {
      api
        .get(props.url)
        .then((response: AxiosResponse) => {
          // Defino el nombre de las columnas !!!
          option.value.yAxis = {
            type: 'category',
            data: response.data.map(
              (item: GraficoTortaInterface) => item.nombre
            ),

            axisLabel: {
              //margin: 15,
              //interval: 0,
              //rotate: 30,
            },
          };

          // Cargo los datos !
          option.value.series = [
            {
              type: 'bar',
              label: {
                show: true,
              },
              data: response.data.map(
                (item: GraficoTortaInterface) => item.total
              ),
              itemStyle: {
                // Configuración de colores para cada barra
                color: function (params) {
                  if (response.data[0].color === undefined) {
                    let color =
                      '#' +
                      ((Math.random() * 0xffffff) << 0)
                        .toString(16)
                        .padStart(6, '0');
                    return color;
                  } else {
                    var colorList = response.data.map(
                      (item: GraficoTortaInterface) => item.color
                    );
                    return colorList[params.dataIndex];
                  }
                },
              },
            },
          ];
        })
        .finally(() => {
          chartInstance = echarts.init(chartRef.value as HTMLDivElement);
          chartInstance.setOption(option.value);
        });
    }

    return {
      chartRef,
      option,
    };
  },
});
</script>
